.TL
\fR\s-6Why\s0\fP
.br
the Unix Philosophy
.br
.vs -4
\fR\s-6still matters\s0\fP
.AU
.ft R
.sp 1.2i
.ps 11
markus schnalke <meillo@marmaro.de>


.S "goals of this talk
.I
introduce the Unix Phil
.I
show that most modern software is crap
.I
explain why the Unix Phil leads to better software
.I
convince you that good software is of matter
.sp 2
.I
make you think


.S "roadmap
.I
Historical background
.I
What is the Unix Philosophy?
.I
The Unix Phil after Gancarz
.I
Discussion on real world examples
.I
The Unix Phil is more than software dev guidelines



.S "me and the UP
.LP
first contact: through the suckless project
.LP
``cat -v Considered Harmful''
.LP
``The Unix and the Echo''
.LP
``The Unix Programming Environment''
.sp 1
.LP
better understanding through digging in the past





.P "historical background




.S "historical background
.I
the late 60s and early 70s
.I
operating systems are complex
.I
MULTICS just failed
.I
Brooks' ``The Mythical Man-Month''
.I
a lot of different hardware
.I
limited computing power
.I
textual input and output (line printers)


.S "everything is a file
.LP
is the(?) basic concept in Unix (and even more in Plan9)
.LP
made simple operating systems possible
.LP
it is not covered by the Unix Phil; the Unix Phil is on a different level
.sp 2
.LP
Unix is mainly two things:
.I
an operating system (system calls)
.I
a toolchest (coreutils)



.P "What is the Unix Phil



.S "What is the Unix Phil *itself*?
.LP
``The Unix philosophy is a set of cultural norms and philosophical
approaches to developing software based on the experience of
leading developers of the Unix operating system.''
(wikipedia)
.sp 2
.LP
How the inventors of Unix write software.
.LP
Common things of classic Unix tools.
.sp 2
.LP
difficult to define


.S "Unix Phil vs. SW dev processes
.LP
the Unix Phil
.I
much: *what* to program
.I
few: *how* to program

.LP
Software developments processes:
.I
few: *what* to program
.I
much: *how* to program

.sp 2
.LP
Extreme Programming is like the Unix Phil
but with more *how* than *what*,
and with formalisms





.S "What is the Unix Phil?
.I
Doug McIlroy (1978)
.I
Mike Gancarz: ``The Unix Philosophy'' (1994)
.I
Eric S. Raymond: ``The Art of Unix Programming'' (2003)
.sp 2
.I
Richard Gabriel: ``Worse is Better'' (1989)


.S "Doug McIlroy
.LP
This is the Unix philosophy:
.I
Write programs that do one thing and do it well.
.I
Write programs to work together.
.I
Write programs to handle text streams, because that is a universal interface.


.S "Mike Gancarz: ``The Unix Philosophy''
.I
Small is beautiful.
.I
Make each program do one thing well.
.I
Build a prototype as soon as possible.
.I
Choose portability over efficiency.
.I
Store data in flat text files.
.I
Use software leverage to your advantage.
.I
Use shell scripts to increase leverage and portability.
.I
Avoid captive user interfaces.
.I
Make every program a filter.
.sp 1
.LP
plus ten lesser tenets




.P "The Unix Phil after Gancarz



.S "Small is beautiful
.I
small software is easier to understand, write, maintain
.I
less lines of code contain less bugs
.I
monsters are large


.S "Make each program do one thing well
.I
programs with many functions are large
.I
one thing is easier to understand
.I
often straight forward to implement
.I
reusable


.S "Build a prototype as soon as possible
.I
shows the quality of the design
.I
shows the problems of the software
.I
the best way to shape a software
.I
users find bugs


.S "Choose portability over efficiency
.I
(comes from incompatible hardware in history)
.I
use is most important
.I
availability
.I
only needs to be fast enough


.S "Store data in flat text files
.LP
binary data is machine dependent
.LP
human readable data is:
.I
is very likely supported
.I
good to port
.I
many tools work on it (Unix toolchest)
.I
as generic as possible
.LP
processing needs only to be fast enough


.S "Use software leverage to your advantage
.LP
what do we have computers for?
.LP
make best use of computing power
.LP
reduce development effort


.S "Use shell scripts to increase leverage and portability
.LP
was very important in history
.LP
high level languages
.LP
prototyping
.LP
quick hacks


.S "Avoid captive user interfaces
.LP
don't assume the user to be human
.LP
exclude the user whenever possible
.LP
automate


.S "Make every program a filter
.LP
programs transform data
.LP
combine programs
.LP
have one common interface



.S "a different POV
.I
pipes
.I
interface design
.I
the toolchest approach
.I
a powerful shell
.I
worse is better
.I
upgrowth and survival



.P "real world examples


.S "various
.LP
who uses
.CW "grep -R
?

.sp 1
.LP
.CW "cat -v

.sp 1
.LP
pagers are taken for granted

.sp 1
.LP
what about the readline?



.S "find -printf
.LP
How to reformat the output of find(1) to have ``FILENAME PATH''
instead of ``PATH/FILENAME''?

.LP
the ``easy'' way:
\f(CWfind /dir -printf "%P %h\en"\fP

.LP
the ``good'' way:
.br
.CW "\s-1find /dir | sed 's,\e(.*\e)/\e(.*\e),\e2 \e1,'

.LP
The difference shows off when one wants, for instance,
the path to be manipulated further.


.S "MH / nmh
.LP
a Mail User Agent (MUA)
.LP
is a toolchest
.LP
work with mails like with generic files
.LP
the only(?) MUA that follows the Unix Phil
.LP
has a very special feeling


.S "uzbl
.LP
a web browser that adheres to the Unix Phil
.LP
a young project (about 1 year)
.LP
central question: what is the one task a web browser covers?
.LP
makes very visible use of software leverage
.LP
suffers hard from our broken web





.P "more than software dev guidelines


.S "say no
.LP
in today's computer world, the Unix Phil is much of asceticism
.LP
one needs to abjure a lot of ``nice'' features
.LP
IMO that leads to a valuable attitude


.S "avoid complexity
.LP
avoid complexity first and foremost
.LP
complexity is the ``boss enemy'', software developers fight against
.LP
strive for simplicity, clarity, generality


.S "good solutions
.LP
we don't need just solutions, we need good ones
.LP
today, we can make almost everything possible,
but we still cannot make it good


.S "live it
.LP
the Unix Phil is not just a few guidelines
.LP
you cannot follow just some of the tenets
.LP
you will not understand the Unix Phil when you don't engage with it
.sp 3
.LP
.ce
it's a philosophy \(en live it!



.P "literature


.S literature
.I
``\fBThe Unix Philosophy\fP''
by Mike Gancarz
.br
Go and get it!
.I
``\fBThe Unix Programming Environment\fP''
by Kernighan and Pike
.br
A Bible for Unix-lovers.
.I
``\fBThe Mythical Man-Month\fP''
by Fred Brooks
.br
The case about complexity.
.I
``\fBThe Practice of Programming\fP''
by Kernighan and Pike
.br
How good code should look like.
.I
``\fBcat -v Considered Harmful\fP''
by Pike and Kernighan
.CW \s-2http://harmful.cat-v.org/cat-v/\s+2
.br
A must-read.


.S
.LP
this talk was prepared using tools of the Heirloom project:
.CW \s-2http://heirloom.sf.net\s+2
.LP
the slides macros are based on
.br
.CW \s-2http://repo.cat-v.org/troff-slider/\s+2
.sp

.LP
the slides are available on my website
.CW \s-2http://marmaro.de/docs\s+2
and on
.CW \s-2http://ulm.ccc.de/ChaosSeminar/\s+2
.sp

2010-03-08
